Index: trunk/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 42)
+++ trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 56)
@@ -678,227 +828,104 @@
 #endif
 
+#if HHI_INTER_VIEW_MOTION_PRED
+        m_acTEncTopList[iViewIdx]->initNewPic( pcPicYuvOrg, ( m_uiMultiviewMvRegMode && iViewIdx ? pcPdmDepthOrg : 0 ) );
+#else
+        m_acTEncTopList[iViewIdx]->initNewPic( pcPicYuvOrg );
+#endif
+
         // increase number of received frames
-        m_iFrameRcvdVector[iViewIdx]++ ;
-      }
-
-#if HHI_INTER_VIEW_MOTION_PRED
-      m_acTEncTopList[iViewIdx]->receivePic( bEos[iViewIdx],  pcPicYuvOrg, m_cListPicYuvRecList[iViewIdx]->back(), ( m_uiMultiviewMvRegMode && iViewIdx ? pcPdmDepthOrg : 0 ) );
-#else
-      m_acTEncTopList[iViewIdx]->receivePic( bEos[iViewIdx],  pcPicYuvOrg, m_cListPicYuvRecList[iViewIdx]->back(), 0 );
-#endif
-
+        m_frameRcvd[iViewIdx]++;
+        frmCnt++;
+        // check end of file
+        eos[iViewIdx] = ( m_acTVideoIOYuvInputFileList[iViewIdx]->isEof() == 1 ?   true : false  );
+        eos[iViewIdx] = ( m_frameRcvd[iViewIdx] == m_iFrameToBeEncoded ?    true : eos[iViewIdx]   );
+        allEos = allEos|eos[iViewIdx] ; 
+      }
       if( m_bUsingDepthMaps )
       {
-        if (!bDepthEos[iViewIdx] && bContinueReadingDepthPics[iViewIdx] )
+        Int frmCntDepth = 0;
+        while ( !depthEos[iViewIdx] && !(frmCntDepth == gopSize))
         {
           // get buffers
-          xGetBuffer( pcPicYuvRec, iViewIdx, m_cListPicYuvDepthRecList ); // ringbuffer of size gopsize -> m_cListPicYuvRec, m_cListBitstream
+          xGetBuffer(pcDepthPicYuvRec, iViewIdx, true);
+
           // read input YUV file
-          m_acTVideoIOYuvDepthInputFileList[iViewIdx]->read( pcDepthPicYuvOrg, m_aiPad  ) ;
-          bDepthEos[iViewIdx] = ( m_acTVideoIOYuvDepthInputFileList[iViewIdx]->isEof() == 1 ?   true : false  );
-          bDepthEos[iViewIdx] = ( m_iDepthFrameRcvdVector[iViewIdx] == (m_iFrameToBeEncoded - 1) ?    true : bDepthEos[iViewIdx]   );
-          bAllDepthEos = bAllDepthEos|bDepthEos[iViewIdx] ;
+          m_acTVideoIOYuvDepthInputFileList[iViewIdx]->read( pcDepthPicYuvOrg, m_aiPad );
+
+          m_acTEncDepthTopList[iViewIdx]->initNewPic( pcDepthPicYuvOrg );
+
           // increase number of received frames
-          m_iDepthFrameRcvdVector[iViewIdx]++ ;
+          m_depthFrameRcvd[iViewIdx]++;
+          frmCntDepth++;
+          // check end of file
+          depthEos[iViewIdx] = ( m_acTVideoIOYuvDepthInputFileList[iViewIdx]->isEof() == 1 ?   true : false  );
+          depthEos[iViewIdx] = ( m_depthFrameRcvd[iViewIdx] == m_iFrameToBeEncoded ?    true : depthEos[iViewIdx]   );
+          allEos = allEos|depthEos[iViewIdx] ; 
         }
-        m_acTEncDepthTopList[iViewIdx]->receivePic( bDepthEos[iViewIdx],  pcDepthPicYuvOrg, m_cListPicYuvDepthRecList[iViewIdx]->back() );
-      }
-    }
-
-    //===== store current POC =====
-    Bool  bCurrPocCoded = m_acTEncTopList[ 0 ]->currentPocWillBeCoded();
-    Int   iCurrPoc      = m_acTEncTopList[ 0 ]->getNextFrameId();
-
-    //===== update camera parameters =====
-    if( bCurrPocCoded )
-    {
-      m_cCameraData.update( (UInt)iCurrPoc );
-    }
-
-#if HHI_VSO    
-    if ( m_bUseVSO && ( m_uiVSOMode != 4) )
-    {
-      //GT: Read external reference pics or render references
-      xStoreVSORefPicsInBuffer();       //GT;
-    }
-#endif
-
-#if FLEX_CODING_ORDER
-    if (m_b3DVFlexOrder)
-    {
-      Int i=0;
-      Int iViewIdx = 0;
-      bool bThisViewContinueReadingPics = false;
-      bool bThisViewContinueReadingDepthPics = false;
-      Int iNumberofDepthViews = m_bUsingDepthMaps?m_iNumberOfViews:0;
-      for(Int j=0; j < (m_iNumberOfViews+ iNumberofDepthViews); j++ )     // Start encoding
-      {
-        if (m_pchMVCJointCodingOrder[i]=='T')
+      }
+    }
+    for ( Int gopId=0; gopId < gopSize; gopId++ )
+    {
+      Int  iNumEncoded = 0;
+      UInt iNextPoc = m_acTEncTopList[0] -> getFrameId( gopId );
+      if ( iNextPoc < m_iFrameToBeEncoded )
+      {
+      m_cCameraData.update( iNextPoc );
+      }
+      for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
+      {
+        iNumEncoded = 0;
+        // call encoding function for one frame
+        m_acTEncTopList[iViewIdx]->encode( eos[iViewIdx], pcPicYuvOrg, *m_picYuvRec[iViewIdx], outputAccessUnits, iNumEncoded, gopId );
+        xWriteOutput(bitstreamFile, iNumEncoded, outputAccessUnits, iViewIdx, false);
+        outputAccessUnits.clear();
+        if( m_bUsingDepthMaps )
         {
-          i++;
-          assert(isdigit(m_pchMVCJointCodingOrder[i]));
-          iViewIdx = (Int)(m_pchMVCJointCodingOrder[i]-'0');
-          bThisViewContinueReadingPics = bContinueReadingPics[iViewIdx];
-          m_acTEncTopList[iViewIdx]->encode( bEos[iViewIdx], m_cListPicYuvRecMap[iViewIdx], pcBitstream, bThisViewContinueReadingPics );
-          bContinueReadingPics[iViewIdx]=bThisViewContinueReadingPics;
-          bAllContinueReadingPics = bAllContinueReadingPics||bContinueReadingPics[iViewIdx];
-
-          if(pcBitstream->getNumberOfWrittenBits()!=0)
-          {
-            m_cTVideoIOBitsFile.writeBits( pcBitstream );
-          }
-          pcBitstream->resetBits(); //GT: also done later in ....
-          pcBitstream->rewindStreamPacket( );
-          // write bistream to file if necessary
-          xWriteOutput( iViewIdx ); //GT: Write Reconfiles (when gop is complete?)
-          i++;
+          Int  iNumDepthEncoded = 0;
+          // call encoding function for one depth frame
+          m_acTEncDepthTopList[iViewIdx]->encode( depthEos[iViewIdx], pcDepthPicYuvOrg, *m_picYuvDepthRec[iViewIdx], outputAccessUnits, iNumDepthEncoded, gopId );
+          xWriteOutput(bitstreamFile, iNumDepthEncoded, outputAccessUnits, iViewIdx, true);
+          outputAccessUnits.clear();
         }
-        else if ( m_pchMVCJointCodingOrder[i] == 'D')
-        {
-          i++;
-          if( m_bUsingDepthMaps )
-          {
-            assert(isdigit(m_pchMVCJointCodingOrder[i]));
-            iViewIdx = (Int)(m_pchMVCJointCodingOrder[i]-'0');
-            bThisViewContinueReadingDepthPics = bContinueReadingDepthPics[iViewIdx];
-            m_acTEncDepthTopList[iViewIdx]->encode( bDepthEos[iViewIdx], m_cListPicYuvDepthRecMap[iViewIdx], pcBitstream, bThisViewContinueReadingDepthPics );
-            bContinueReadingDepthPics[iViewIdx]=bThisViewContinueReadingDepthPics;
-
-            bAllContinueReadingDepthPics = bAllContinueReadingDepthPics||bContinueReadingDepthPics[iViewIdx];
-            if(pcBitstream->getNumberOfWrittenBits()!=0)
-            {
-              m_cTVideoIOBitsFile.writeBits( pcBitstream );
-            }
-            pcBitstream->resetBits();
-            pcBitstream->rewindStreamPacket( );
-            // write bistream to file if necessary
-            xWriteOutput( iViewIdx, true );
-            i++;
-          }
-        }
-      }
-    }
-    else
-    {
-#endif
-    //GT: Encode
-    for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )     // Start encoding
-    {
-      bool bThisViewContinueReadingPics = bContinueReadingPics[iViewIdx];
-      m_acTEncTopList[iViewIdx]->encode( bEos[iViewIdx], m_cListPicYuvRecMap[iViewIdx], pcBitstream, bThisViewContinueReadingPics );
-      bContinueReadingPics[iViewIdx]=bThisViewContinueReadingPics;
-      bAllContinueReadingPics = bAllContinueReadingPics||bContinueReadingPics[iViewIdx];
-
-      if(pcBitstream->getNumberOfWrittenBits()!=0)
-      {
-        m_cTVideoIOBitsFile.writeBits( pcBitstream );
-      }
-      pcBitstream->resetBits(); //GT: also done later in ....
-      pcBitstream->rewindStreamPacket( );
-      // write bistream to file if necessary
-      xWriteOutput( iViewIdx ); //GT: Write Reconfiles (when gop is complete?)
-
-      if( m_bUsingDepthMaps )
-      {
-        bool bThisViewContinueReadingDepthPics = bContinueReadingDepthPics[iViewIdx];
-        m_acTEncDepthTopList[iViewIdx]->encode( bDepthEos[iViewIdx], m_cListPicYuvDepthRecMap[iViewIdx], pcBitstream, bThisViewContinueReadingDepthPics );
-        bContinueReadingDepthPics[iViewIdx]=bThisViewContinueReadingDepthPics;
-
-        bAllContinueReadingDepthPics = bAllContinueReadingDepthPics||bContinueReadingDepthPics[iViewIdx];
-        if(pcBitstream->getNumberOfWrittenBits()!=0)
-        {
-          m_cTVideoIOBitsFile.writeBits( pcBitstream );
-        }
-        pcBitstream->resetBits();
-        pcBitstream->rewindStreamPacket( );
-        // write bistream to file if necessary
-        xWriteOutput( iViewIdx, true );
-      }
-    }
-#if FLEX_CODING_ORDER
-	}
-#endif
-    // delete extra picture buffers
-    if( bCurrPocCoded )
-    {
+      }
+#if HHI_INTERVIEW_SKIP || HHI_INTER_VIEW_MOTION_PRED || HHI_INTER_VIEW_RESIDUAL_PRED
       for( Int iViewIdx = 0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
       {
         if( iViewIdx < (Int)m_acTEncTopList.size() && m_acTEncTopList[iViewIdx] )
         {
-          m_acTEncTopList[iViewIdx]->deleteExtraPicBuffers( iCurrPoc );
+          m_acTEncTopList[iViewIdx]->deleteExtraPicBuffers( m_acTEncTopList[iViewIdx]->getGOPEncoder()->getPocLastCoded() );
         }
         if( iViewIdx < (Int)m_acTEncDepthTopList.size() && m_acTEncDepthTopList[iViewIdx] )
         {
-          m_acTEncDepthTopList[iViewIdx]->deleteExtraPicBuffers( iCurrPoc );
+          m_acTEncDepthTopList[iViewIdx]->deleteExtraPicBuffers( m_acTEncTopList[iViewIdx]->getGOPEncoder()->getPocLastCoded() );
         }
       }
-    }
-
-#if AMVP_BUFFERCOMPRESS
-    // compress motion for entire access
-    if( bCurrPocCoded )
-    {
-      for( Int iViewIdx = 0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
-      {
-        if( iViewIdx < (Int)m_acTEncTopList.size() && m_acTEncTopList[iViewIdx] )
+#endif
+      for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
+      {
+        m_acTEncTopList[iViewIdx]->compressMotion( m_acTEncTopList[iViewIdx]->getGOPEncoder()->getPocLastCoded() );
+        if( m_bUsingDepthMaps )
         {
-          m_acTEncTopList[iViewIdx]->compressMotion( iCurrPoc );
+          m_acTEncDepthTopList[iViewIdx]->compressMotion( m_acTEncDepthTopList[iViewIdx]->getGOPEncoder()->getPocLastCoded() );
         }
-        if( iViewIdx < (Int)m_acTEncDepthTopList.size() && m_acTEncDepthTopList[iViewIdx] )
-        {
-          m_acTEncDepthTopList[iViewIdx]->compressMotion( iCurrPoc );
-        }
-      }
-    }
-#endif
-  }
-
-  // write output
-  for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
-  {
-    m_acTEncTopList[iViewIdx]->printOutSummary(m_acTEncTopList[iViewIdx]->getNumAllPicCoded());
-    if ( m_bUsingDepthMaps )
-    {
-      m_acTEncDepthTopList[iViewIdx]->printOutSummary(m_acTEncDepthTopList[iViewIdx]->getNumAllPicCoded());
-    }
-  }
-
+      }
+    }
+    gopSize = maxGopSize;
+  }
   // delete original YUV buffer
   pcPicYuvOrg->destroy();
   delete pcPicYuvOrg;
   pcPicYuvOrg = NULL;
-
-  // valgrind
-  if( m_bUsingDepthMaps)
-  {
-    pcDepthPicYuvOrg->destroy();
-  }
-  delete pcDepthPicYuvOrg ;
-  pcDepthPicYuvOrg = NULL ;
-
-  pcBitstream->destroy();
-  delete pcBitstream;
-  pcBitstream = NULL ;
-
-
-  // delete used buffers in encoder class
-  for(Int iViewIdx =0; iViewIdx < m_iNumberOfViews; iViewIdx++)
-  {
-    m_acTEncTopList[iViewIdx]->deletePicBuffer() ;
-  }
-
-  if( m_bUsingDepthMaps)
-  {
-    for(Int iViewIdx =0; iViewIdx < m_iNumberOfViews; iViewIdx++)
-    {
-      m_acTEncDepthTopList[iViewIdx]->deletePicBuffer() ;
-    }
-  }
-
-  if ( pcPdmDepthOrg )
-  {
-    pcPdmDepthOrg->destroy();
-    delete pcPdmDepthOrg;
-    pcPdmDepthOrg = NULL;
+  pcDepthPicYuvOrg->destroy();
+  delete pcDepthPicYuvOrg;
+  pcDepthPicYuvOrg = NULL;
+  
+  for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
+  {
+    m_acTEncTopList[iViewIdx]->printOutSummary(m_acTEncTopList[iViewIdx]->getNumAllPicCoded());
+    if ( m_bUsingDepthMaps )
+    {
+      m_acTEncDepthTopList[iViewIdx]->printOutSummary(m_acTEncDepthTopList[iViewIdx]->getNumAllPicCoded());
+    }
   }
 
@@ -906,5 +933,20 @@
   xDeleteBuffer();
   xDestroyLib();
-}
+
+  return;
+}
+
+TEncTop*  TAppEncTop::getTEncTop( Int viewId, Bool isDepth )    
+{ 
+  if ( isDepth )  
+  {
+    return m_acTEncDepthTopList[viewId]; 
+  } 
+  else
+  { 
+    return m_acTEncTopList[viewId]; 
+  } 
+}
+
 
 // ====================================================================================================================
@@ -918,150 +960,129 @@
  .
  */
-Void TAppEncTop::xGetBuffer( TComPicYuv*& rpcPicYuvRec, Int iViewIdx, std::vector< TComList<TComPicYuv*>*>& racBuffer )
-{
-  if ( m_uiCodedPictureStoreSize   == 0 )
-    {
-      if (racBuffer[iViewIdx]->size() == 0)
-      {
-        rpcPicYuvRec = new TComPicYuv;
-        rpcPicYuvRec->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-
-        racBuffer[iViewIdx]->pushBack( rpcPicYuvRec );
-      }
-      rpcPicYuvRec = racBuffer[iViewIdx]->popFront(); //GT why? only one in list ?? A: only to get rpcPicYuvRec
-      racBuffer[iViewIdx]->pushBack( rpcPicYuvRec );
-      return;
-    }
-
-    // org. buffer
-  if ( racBuffer[iViewIdx]->size() == (UInt)m_uiCodedPictureStoreSize )
-    {
-      rpcPicYuvRec = racBuffer[iViewIdx]->popFront();
+Void TAppEncTop::xGetBuffer( TComPicYuv*& rpcPicYuvRec, Int iViewIdx, Bool isDepth)
+{
+  assert( m_iGOPSize > 0 );
+  
+  if( !isDepth )
+  {
+    if ( m_picYuvRec[iViewIdx]->size() == (UInt)m_iGOPSize )
+    {
+      rpcPicYuvRec = m_picYuvRec[iViewIdx]->popFront();
     }
     else
     {
-      rpcPicYuvRec = new TComPicYuv;
+      rpcPicYuvRec = new TComPicYuv; 
       rpcPicYuvRec->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
     }
-    racBuffer[iViewIdx]->pushBack( rpcPicYuvRec );
+    m_picYuvRec[iViewIdx]->pushBack( rpcPicYuvRec );
+  }
+  else
+  {
+    if ( m_picYuvDepthRec[iViewIdx]->size() == (UInt)m_iGOPSize )
+    {
+      rpcPicYuvRec = m_picYuvDepthRec[iViewIdx]->popFront();
+    }
+    else
+    {
+      rpcPicYuvRec = new TComPicYuv; 
+      rpcPicYuvRec->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
+    }
+    m_picYuvDepthRec[iViewIdx]->pushBack( rpcPicYuvRec );
+  }
 }
 
 Void TAppEncTop::xDeleteBuffer( )
 {
-  TComList<TComBitstream*>::iterator iterBitstream = m_cListBitstream.begin();
-
-  Int iSize = Int( m_cListBitstream.size() );
-
-  for ( Int i = 0; i < iSize; i++ )
-  {
-    TComBitstream* pcBitstream = *(iterBitstream++);
-
-    pcBitstream->destroy();
-
-    delete pcBitstream; pcBitstream = NULL;
-  }
-
-  for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
-  {
-    TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_cListPicYuvRecList[iViewIdx]->begin();
-
-    iSize = Int( m_cListPicYuvRecList[iViewIdx]->size() );
-
-    for ( Int i = 0; i < iSize; i++ )
-    {
+  for(Int iViewIdx=0; iViewIdx<m_picYuvRec.size(); iViewIdx++)
+  {
+    if(m_picYuvRec[iViewIdx])
+    {
+      TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_picYuvRec[iViewIdx]->begin();
+      Int iSize = Int( m_picYuvRec[iViewIdx]->size() );
+      for ( Int i = 0; i < iSize; i++ )
+      {
         TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
-        pcPicYuvRec->destroy();
-        delete pcPicYuvRec; pcPicYuvRec = NULL;
-    }
-  }
-  if( m_bUsingDepthMaps)
-  {
-    for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
-    {
-      TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_cListPicYuvDepthRecList[iViewIdx]->begin();
-
-      iSize = Int( m_cListPicYuvDepthRecList[iViewIdx]->size() );
-
+        if(pcPicYuvRec)
+        {
+          pcPicYuvRec->destroy();
+          delete pcPicYuvRec; 
+          pcPicYuvRec = NULL;
+        }
+      }
+    } 
+  }
+  for(Int iViewIdx=0; iViewIdx<m_picYuvDepthRec.size(); iViewIdx++)
+  {
+    if(m_picYuvDepthRec[iViewIdx])
+    {
+      TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_picYuvDepthRec[iViewIdx]->begin();
+      Int iSize = Int( m_picYuvDepthRec[iViewIdx]->size() );
       for ( Int i = 0; i < iSize; i++ )
       {
-          TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
+        TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
+        if(pcPicYuvRec)
+        {
           pcPicYuvRec->destroy();
-          delete pcPicYuvRec; pcPicYuvRec = NULL;
-      }
-    }
-  }
-
-  // Delete ERFiles
-
-#if HHI_VSO
-  std::map< Int,vector<TComPicYuv*> >::iterator iterMapPicExtRefView = m_cMapPicExtRefView.begin();
-  while ( iterMapPicExtRefView != m_cMapPicExtRefView.end() )
-  {
-    for ( UInt uiViewNumber = 0; uiViewNumber < iterMapPicExtRefView->second.size(); uiViewNumber++ )
-    {
-      if ( iterMapPicExtRefView->second[uiViewNumber] )
-      {
-        iterMapPicExtRefView->second[uiViewNumber]->destroy();
-        delete iterMapPicExtRefView->second[uiViewNumber];
-      }
-    }
-    iterMapPicExtRefView++;
-  }
-#endif
+          delete pcPicYuvRec; 
+          pcPicYuvRec = NULL;
+        }
+      } 
+    }
+  }
 }
 
 /** \param iNumEncoded  number of encoded frames
  */
-Void TAppEncTop::xWriteOutput( Int iViewIdx, Bool isDepth )
-{
-  std::map<PicOrderCnt, TComPicYuv*> &rcMap = ( isDepth ? m_cListPicYuvDepthRecMap          : m_cListPicYuvRecMap          )[iViewIdx];
-  PicOrderCnt  &riNextPocToDump             = ( isDepth ? m_aiNextDepthPocToDump            : m_aiNextPocToDump            )[iViewIdx];
-  TVideoIOYuv* &rpcTVideoIOYuvReconFile     = ( isDepth ? m_acTVideoIOYuvDepthReconFileList : m_acTVideoIOYuvReconFileList )[iViewIdx];
-  std::map<PicOrderCnt, TComPicYuv*>::iterator i;
-
-  while( ! rcMap.empty() && ( i = rcMap.begin() )->first == riNextPocToDump )
-  {
-    riNextPocToDump++;
-    rpcTVideoIOYuvReconFile->write( i->second, m_aiPad );
-    rcMap.erase( i );
-  }
-}
-
-// GT FIX
-std::vector<TComPic*> TAppEncTop::getSpatialRefPics( Int iViewIdx, Int iPoc, Bool bIsDepthCoder )
-{
-  std::vector<TComPic*> apcRefPics( iViewIdx, (TComPic*)NULL );
-  for( int iRefViewIdx = 0; iRefViewIdx < iViewIdx; iRefViewIdx++ )
-  {
-// GT FIX
-    TComPic* pcRefPic = xGetPicFromView(iRefViewIdx, iPoc, bIsDepthCoder);
-
-    assert( pcRefPic != NULL );
-    apcRefPics[iRefViewIdx] = pcRefPic;
-  }
-  return apcRefPics;
-}
-
-
-TComPic* TAppEncTop::xGetPicFromView( Int iViewIdx, Int iPoc, bool bDepth )
-{
-  assert( ( iViewIdx >= 0) && ( iViewIdx < m_iNumberOfViews ) );
-
-  TComPic* pcPic = 0;
-  TComList<TComPic*>* apcListPic;
-
-  apcListPic = (bDepth ?  m_acTEncDepthTopList[iViewIdx] : m_acTEncTopList[iViewIdx])->getListPic() ;
-
-  for(TComList<TComPic*>::iterator it=apcListPic->begin(); it!=apcListPic->end(); it++)
-  {
-    if( (*it)->getPOC() == iPoc )
-    {
-      pcPic = *it ;
-      break ;
-    }
-  }
-
-  return pcPic;
-};
+Void TAppEncTop::xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, std::list<AccessUnit>& accessUnits, Int iViewIdx, Bool isDepth )
+{
+  Int i;
+  
+  if( iNumEncoded > 0 )
+  {
+    TComList<TComPicYuv*>::iterator iterPicYuvRec = !isDepth ? m_picYuvRec[iViewIdx]->end() : m_picYuvDepthRec[iViewIdx]->end();
+  
+    for ( i = 0; i < iNumEncoded; i++ )
+    {
+      --iterPicYuvRec;
+    }
+  
+    for ( i = 0; i < iNumEncoded; i++ )
+    {
+      TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
+      if( !isDepth )
+      {
+        if (m_pchReconFileList[iViewIdx])
+        {
+#if PIC_CROPPING
+          m_acTVideoIOYuvReconFileList[iViewIdx]->write( pcPicYuvRec, m_cropLeft, m_cropRight, m_cropTop, m_cropBottom );
+#else
+          m_acTVideoIOYuvReconFileList[iViewIdx]->write( pcPicYuvRec, m_aiPad );
+#endif
+        }
+      }
+      else
+      {
+        if (m_pchDepthReconFileList[iViewIdx])
+        {
+#if PIC_CROPPING
+          m_acTVideoIOYuvDepthReconFileList[iViewIdx]->write( pcPicYuvRec, m_cropLeft, m_cropRight, m_cropTop, m_cropBottom );
+#else
+          m_acTVideoIOYuvDepthReconFileList[iViewIdx]->write( pcPicYuvRec, m_aiPad );
+#endif
+        }
+      }
+    }
+  }
+  if( ! accessUnits.empty() )
+  {
+    list<AccessUnit>::iterator aUIter;
+    for( aUIter = accessUnits.begin(); aUIter != accessUnits.end(); aUIter++ )
+    {
+      const vector<unsigned>& stats = writeAnnexB(bitstreamFile, *aUIter);
+      rateStatsAccum(*aUIter, stats);
+    }
+  }
+}
+
 
 TComPicYuv* TAppEncTop::xGetPicYuvFromView( Int iViewIdx, Int iPoc, Bool bDepth, Bool bRecon )
@@ -1088,187 +1109,38 @@
 };
 
-#if HHI_VSO
-Void TAppEncTop::xSetBasePicYuv( Int iViewIdx, Int iPoc, TComMVDRefData* pcRefInfo, InterViewReference eView, bool bDepth )
-{
-
-  if ( ( iViewIdx < 0) || ( iViewIdx >= m_iNumberOfViews ) )
-    return;
-
-  if ( !m_bUsingDepthMaps && bDepth )
-    return;
-
-  TComPic* pcPic = xGetPicFromView( iViewIdx, iPoc, bDepth);
-
-  if (pcPic == 0)
-    return;
-
-  pcRefInfo->setPicYuvBaseView(eView, bDepth, pcPic->getPicYuvOrg(),  pcPic->getReconMark() ? pcPic->getPicYuvRec() : NULL );
-
-};
-
-Void TAppEncTop::setMVDPic( Int iViewIdx, Int iPoc, TComMVDRefData* pcMVDRefData )
-{
-  AOF( iViewIdx >= 0);
-  AOF( iViewIdx <  m_iNumberOfViews  );
-
-  xSetBasePicYuv(iViewIdx - 1, iPoc, pcMVDRefData, PREVVIEW, false);
-  xSetBasePicYuv(iViewIdx    , iPoc, pcMVDRefData, CURRVIEW, false );
-  xSetBasePicYuv(iViewIdx + 1, iPoc, pcMVDRefData, NEXTVIEW, false );
-
-  if ( m_bUsingDepthMaps )
-  {
-    xSetBasePicYuv(iViewIdx - 1, iPoc, pcMVDRefData, PREVVIEW, true );
-    xSetBasePicYuv(iViewIdx    , iPoc, pcMVDRefData, CURRVIEW, true );
-    xSetBasePicYuv(iViewIdx + 1, iPoc, pcMVDRefData, NEXTVIEW, true );
-  }
-
-
-  xSetBaseLUT       (iViewIdx, iViewIdx-1  , pcMVDRefData, PREVVIEW );
-  xSetBaseLUT       (iViewIdx, iViewIdx+1  , pcMVDRefData, NEXTVIEW );
-
-
-  if ( m_bUseVSO && m_uiVSOMode != 4)
-  {
-    xSetERPicYuvs               (iViewIdx, iPoc, pcMVDRefData);
-    pcMVDRefData->setShiftLUTsERView(m_cCameraData.getSynthViewShiftLUTD()[iViewIdx],  m_cCameraData.getSynthViewShiftLUTI()[iViewIdx] );
-    pcMVDRefData->setRefViewInd     (m_aaiBaseViewRefInd[iViewIdx], m_aaiERViewRefInd[iViewIdx], m_aaiERViewRefLutInd[iViewIdx]);
-  }
-};
-
-
-Void TAppEncTop::xSetBaseLUT( Int iViewIdxSource, Int iViewIdxTarget, TComMVDRefData* pcRefInfo, InterViewReference eView )
-{
-  if ( ( iViewIdxSource < 0) || ( iViewIdxSource >= m_iNumberOfViews )||( iViewIdxTarget < 0) || ( iViewIdxTarget >= m_iNumberOfViews ) )
-    return;
-  assert( abs( iViewIdxTarget - iViewIdxSource ) <= 1 );  //GT; Not supported yet
-  pcRefInfo->setShiftLUTsBaseView(eView, m_cCameraData.getBaseViewShiftLUTD()[iViewIdxSource][iViewIdxTarget],m_cCameraData.getBaseViewShiftLUTI()[iViewIdxSource][iViewIdxTarget] );
-};
-
-Void TAppEncTop::xSetERPicYuvs( Int iViewIdx, Int iPoc, TComMVDRefData* pcReferenceInfo )
-{
-  std::vector<TComPicYuv*> apcExtRefViews;
-
-  std::map< Int, vector<TComPicYuv*> >::iterator cMapIt;
-  cMapIt = m_cMapPicExtRefView.find(iPoc);
-
-  assert(  cMapIt != m_cMapPicExtRefView.end() );
-
-  pcReferenceInfo->setPicYuvERViews( cMapIt->second );
-}
-
-Void TAppEncTop::xStoreVSORefPicsInBuffer()
-{
-  // X-Check if all Encoders have received the same number of pics
-  Int iNumRcvd = m_iFrameRcvdVector[0];
-  for ( UInt uiViewNumber = 0; uiViewNumber < m_iNumberOfViews; uiViewNumber ++ )
-  {
-    assert( ( m_iFrameRcvdVector[uiViewNumber] == iNumRcvd ) && ( m_iDepthFrameRcvdVector[uiViewNumber] == iNumRcvd ) ); //GT; if assert here, the encoder instances are not synchronized any more, re-think this function and the ERView Buffer!!
-  };
-
-  Int iCurPoc = iNumRcvd - 1;
-
-  if ( iCurPoc <= m_iLastFramePutInERViewBuffer )
-  {
-    return;
-  }
-
-  std::vector<TComPicYuv*> apcExtRefViewVec;
-
-  Int iNumberOfReferenceViews = 0;
-  if (m_iNumberOfExternalRefs != 0)
-  {
-    m_aaiERViewRefLutInd = m_aaiERViewRefInd;
-    // Insert Rendered Views form File
-
-    iNumberOfReferenceViews = m_iNumberOfExternalRefs;
-
-    for ( UInt uiViewNumber = 0; uiViewNumber < iNumberOfReferenceViews; uiViewNumber++ )
-    {
-      TComPicYuv* pcPicYuvERView = new TComPicYuv;
-      pcPicYuvERView->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-
-      m_acTVideoIOYuvERFileList[uiViewNumber]->read( pcPicYuvERView, m_aiPad  ) ;
-
-      apcExtRefViewVec.push_back( pcPicYuvERView );
-    }
-  }
-  else
-  { //Render Views
-
-    for ( UInt uiViewNumber = 0; uiViewNumber < m_iNumberOfViews; uiViewNumber++ )
-    {
-      m_aaiERViewRefInd   [uiViewNumber].clear();
-      m_aaiERViewRefLutInd[uiViewNumber].clear();
-    }
-
-    iNumberOfReferenceViews = 0;
-    for ( UInt iSynthViewIdx = 0; iSynthViewIdx < m_cCameraData.getSynthViewNumbers().size(); iSynthViewIdx++ )
-    {
-      // Get Left and right view
-      Int  iLeftViewIdx  = -1;
-      Int  iRightViewIdx = -1;
-      Bool bIsBaseView;
-
-      Int iRelDistToLeft;
-      m_cCameraData.getLeftRightBaseView( iSynthViewIdx, iLeftViewIdx, iRightViewIdx, iRelDistToLeft, bIsBaseView );
-
-      if  ((iLeftViewIdx == -1) || (iRightViewIdx == -1))
-      {
-        std::cerr << "Left or right View not given." << endl;
-        exit(EXIT_FAILURE);
-      }
-
-      m_cRendererTop.setShiftLUTs(
-        m_cCameraData.getSynthViewShiftLUTD()[iLeftViewIdx] [iSynthViewIdx],
-        m_cCameraData.getSynthViewShiftLUTI()[iLeftViewIdx] [iSynthViewIdx],
-        m_cCameraData.getBaseViewShiftLUTI ()[iLeftViewIdx] [iRightViewIdx],
-        m_cCameraData.getSynthViewShiftLUTD()[iRightViewIdx][iSynthViewIdx],
-        m_cCameraData.getSynthViewShiftLUTI()[iRightViewIdx][iSynthViewIdx],
-        m_cCameraData.getBaseViewShiftLUTI ()[iRightViewIdx][iLeftViewIdx],
-        iRelDistToLeft
-      );
-      if ( bIsBaseView ) continue;
-
-      // Render from left
-      TComPicYuv* pcPicYuvERView = new TComPicYuv;
-      pcPicYuvERView->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-      m_cRendererTop.extrapolateView( xGetPicFromView( iLeftViewIdx, iCurPoc, false )->getPicYuvOrg(), xGetPicFromView( iLeftViewIdx, iCurPoc, true )->getPicYuvOrg(), pcPicYuvERView, true );
-
-      apcExtRefViewVec.push_back( pcPicYuvERView );
-
-      m_aaiERViewRefInd   [ iLeftViewIdx].push_back( iNumberOfReferenceViews );
-      m_aaiERViewRefLutInd[ iLeftViewIdx].push_back( iSynthViewIdx );
-      iNumberOfReferenceViews++;
-
-      //Render from right
-      pcPicYuvERView = new TComPicYuv;
-      pcPicYuvERView->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-
-      m_cRendererTop.extrapolateView( xGetPicFromView( iRightViewIdx, iCurPoc, false )->getPicYuvOrg(), xGetPicFromView( iRightViewIdx, iCurPoc, true )->getPicYuvOrg(), pcPicYuvERView, false );
-      apcExtRefViewVec.push_back( pcPicYuvERView );
-
-      m_aaiERViewRefInd   [ iRightViewIdx].push_back( iNumberOfReferenceViews );
-      m_aaiERViewRefLutInd[ iRightViewIdx].push_back( iSynthViewIdx );
-      iNumberOfReferenceViews++;
-    }
-  }
-
-  m_iLastFramePutInERViewBuffer++;
-  m_cMapPicExtRefView.insert( std::make_pair( m_iLastFramePutInERViewBuffer, apcExtRefViewVec ) );
-
-  if ( m_cMapPicExtRefView.size() >  (UInt)m_iGOPSize + 1 )
-  {
-    for ( UInt uiViewNumber = 0; uiViewNumber < (UInt) m_cMapPicExtRefView.begin()->second.size(); uiViewNumber++ )
-    {
-      if ( m_cMapPicExtRefView.begin()->second[uiViewNumber] )
-      {
-        m_cMapPicExtRefView.begin()->second[uiViewNumber]->destroy();
-        delete m_cMapPicExtRefView.begin()->second[uiViewNumber];
-      }
-    }
-    m_cMapPicExtRefView.erase ( m_cMapPicExtRefView.begin() );
-  }
-}
-#endif
+/**
+ *
+ */
+void TAppEncTop::rateStatsAccum(const AccessUnit& au, const std::vector<unsigned>& annexBsizes)
+{
+  AccessUnit::const_iterator it_au = au.begin();
+  vector<unsigned>::const_iterator it_stats = annexBsizes.begin();
+
+  for (; it_au != au.end(); it_au++, it_stats++)
+  {
+    switch ((*it_au)->m_nalUnitType)
+    {
+    case NAL_UNIT_CODED_SLICE:
+#if H0566_TLA
+    case NAL_UNIT_CODED_SLICE_IDV:
+    case NAL_UNIT_CODED_SLICE_TLA:
+    case NAL_UNIT_CODED_SLICE_CRA:
+#else
+    case NAL_UNIT_CODED_SLICE_DATAPART_A:
+    case NAL_UNIT_CODED_SLICE_DATAPART_B:
+    case NAL_UNIT_CODED_SLICE_CDR:
+#endif
+    case NAL_UNIT_CODED_SLICE_IDR:
+    case NAL_UNIT_SPS:
+    case NAL_UNIT_PPS:
+      m_essentialBytes += *it_stats;
+      break;
+    default:
+      break;
+    }
+
+    m_totalBytes += *it_stats;
+  }
+}
 
 #if HHI_INTERVIEW_SKIP
@@ -1277,7 +1149,5 @@
   AOT( iViewIdx <= 0);
   AOT( iViewIdx >= m_iNumberOfViews );
-  AOF( m_uiInterViewSkip != 0 );
   AOF( m_cCameraData.getCurFrameId() == iPoc );
-
   Int iViewSIdx      = m_cCameraData.getBaseId2SortedId()[iViewIdx];
   Int iFirstViewSIdx = m_cCameraData.getBaseId2SortedId()[0];
@@ -1287,5 +1157,5 @@
   Bool bFirstIsLeft = (iFirstViewSIdx < iViewSIdx);
 
-    m_cUsedPelsRenderer.setShiftLUTs(
+  m_cUsedPelsRenderer.setShiftLUTs(
       m_cCameraData.getBaseViewShiftLUTD()[0][iViewIdx],
       m_cCameraData.getBaseViewShiftLUTI()[0][iViewIdx],
@@ -1297,13 +1167,10 @@
       );
 
-
   TComPicYuv* pcPicYuvDepth = xGetPicYuvFromView(0, iPoc, true, true );
   AOF( pcPicYuvDepth);
 
   m_cUsedPelsRenderer.getUsedSamplesMap( pcPicYuvDepth, pcPicYuvUsedSplsMap, bFirstIsLeft );
-
-}
-#endif
-
+}
+#endif
 #if HHI_VSO
 Void TAppEncTop::setupRenModel( Int iPoc, Int iEncViewIdx, Int iEncContent )
@@ -1403,2 +1270,47 @@
 #endif
 
+
+
+/*
+void TAppEncTop::printRateSummary()
+{
+  double time = (double) m_iFrameRcvd / m_iFrameRate;
+  printf("Bytes written to file: %u (%.3f kbps)\n", m_totalBytes, 0.008 * m_totalBytes / time);
+#if VERBOSE_RATE
+  printf("Bytes for SPS/PPS/Slice (Incl. Annex B): %u (%.3f kbps)\n", m_essentialBytes, 0.008 * m_essentialBytes / time);
+#endif
+}
+*/
+
+std::vector<TComPic*> TAppEncTop::getInterViewRefPics( Int viewId, Int poc, Bool isDepth, TComSPS* sps )
+{
+  std::vector<TComPic*> apcRefPics( sps->getNumberOfUsableInterViewRefs(), (TComPic*)NULL );
+  for( Int k = 0; k < sps->getNumberOfUsableInterViewRefs(); k++ )
+  {
+    TComPic* pcRefPic = xGetPicFromView( sps->getUsableInterViewRef( k ) + viewId, poc, isDepth );
+    assert( pcRefPic != NULL );
+    apcRefPics[k] = pcRefPic;
+  }
+  return apcRefPics;
+}
+
+TComPic* TAppEncTop::xGetPicFromView( Int viewIdx, Int poc, Bool isDepth )
+{
+  assert( ( viewIdx >= 0 ) && ( viewIdx < m_iNumberOfViews ) );
+
+  TComList<TComPic*>* apcListPic = (isDepth ?  m_acTEncDepthTopList[viewIdx] : m_acTEncTopList[viewIdx])->getListPic() ;
+
+  TComPic* pcPic = NULL;
+  for(TComList<TComPic*>::iterator it=apcListPic->begin(); it!=apcListPic->end(); it++)
+  {
+    if( (*it)->getPOC() == poc )
+    {
+      pcPic = *it ;
+      break ;
+    }
+  }
+
+  return pcPic;
+};
+
+//! \}
